using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Pipeline.SalesTeam.Cqrs;

public record DeleteSalesTeamRepresentativeCommand(string Id) : IRequest<bool>;

public class DeleteSalesTeamRepresentativeHandler : IRequestHandler<DeleteSalesTeamRepresentativeCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteSalesTeamRepresentativeHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteSalesTeamRepresentativeCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.SalesRepresentative
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null)
        {
            return false;
        }

        _context.SalesRepresentative.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}